diff -uNr nagios-plugins-1.4.11/gl/wctype.in.h nagios-plugins-1.4.12/gl/wctype.in.h
--- nagios-plugins-1.4.11/gl/wctype.in.h	1970-01-01 01:00:00.000000000 +0100
+++ nagios-plugins-1.4.12/gl/wctype.in.h	2008-02-12 12:07:18.000000000 +0100
@@ -0,0 +1,161 @@
+/* A substitute for ISO C99 <wctype.h>, for platforms that lack it.
+
+   Copyright (C) 2006, 2007 Free Software Foundation, Inc.
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 3, or (at your option)
+   any later version.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program; if not, write to the Free Software Foundation,
+   Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.  */
+
+/* Written by Bruno Haible and Paul Eggert.  */
+
+/*
+ * ISO C 99 <wctype.h> for platforms that lack it.
+ * <http://www.opengroup.org/susv3xbd/wctype.h.html>
+ *
+ * iswctype, towctrans, towlower, towupper, wctrans, wctype,
+ * wctrans_t, and wctype_t are not yet implemented.
+ */
+
+#ifndef _GL_WCTYPE_H
+
+#if @HAVE_WINT_T@
+/* Solaris 2.5 has a bug: <wchar.h> must be included before <wctype.h>.
+   Tru64 with Desktop Toolkit C has a bug: <stdio.h> must be included before
+   <wchar.h>.
+   BSD/OS 4.0.1 has a bug: <stddef.h>, <stdio.h> and <time.h> must be
+   included before <wchar.h>.  */
+# include <stddef.h>
+# include <stdio.h>
+# include <time.h>
+# include <wchar.h>
+#endif
+
+/* Include the original <wctype.h> if it exists.
+   BeOS 5 has the functions but no <wctype.h>.  */
+/* The include_next requires a split double-inclusion guard.  */
+#if @HAVE_WCTYPE_H@
+# @INCLUDE_NEXT@ @NEXT_WCTYPE_H@
+#endif
+
+#ifndef _GL_WCTYPE_H
+#define _GL_WCTYPE_H
+
+#if @HAVE_WINT_T@
+typedef wint_t __wctype_wint_t;
+#else
+typedef int __wctype_wint_t;
+#endif
+
+/* FreeBSD 4.4 to 4.11 has <wctype.h> but lacks the functions.
+   Assume all 12 functions are implemented the same way, or not at all.  */
+#if ! @HAVE_ISWCNTRL@
+
+/* IRIX 5.3 has macros but no functions, its isw* macros refer to an
+   undefined variable _ctmp_ and to <ctype.h> macros like _P, and they
+   refer to system functions like _iswctype that are not in the
+   standard C library.  Rather than try to get ancient buggy
+   implementations like this to work, just disable them.  */
+#  undef iswalnum
+#  undef iswalpha
+#  undef iswblank
+#  undef iswcntrl
+#  undef iswdigit
+#  undef iswgraph
+#  undef iswlower
+#  undef iswprint
+#  undef iswpunct
+#  undef iswspace
+#  undef iswupper
+#  undef iswxdigit
+
+static inline int
+iswalnum (__wctype_wint_t wc)
+{
+  return ((wc >= '0' && wc <= '9')
+	  || ((wc & ~0x20) >= 'A' && (wc & ~0x20) <= 'Z'));
+}
+
+static inline int
+iswalpha (__wctype_wint_t wc)
+{
+  return (wc & ~0x20) >= 'A' && (wc & ~0x20) <= 'Z';
+}
+
+static inline int
+iswblank (__wctype_wint_t wc)
+{
+  return wc == ' ' || wc == '\t';
+}
+
+static inline int
+iswcntrl (__wctype_wint_t wc)
+{
+  return (wc & ~0x1f) == 0 || wc == 0x7f;
+}
+
+static inline int
+iswdigit (__wctype_wint_t wc)
+{
+  return wc >= '0' && wc <= '9';
+}
+
+static inline int
+iswgraph (__wctype_wint_t wc)
+{
+  return wc >= '!' && wc <= '~';
+}
+
+static inline int
+iswlower (__wctype_wint_t wc)
+{
+  return wc >= 'a' && wc <= 'z';
+}
+
+static inline int
+iswprint (__wctype_wint_t wc)
+{
+  return wc >= ' ' && wc <= '~';
+}
+
+static inline int
+iswpunct (__wctype_wint_t wc)
+{
+  return (wc >= '!' && wc <= '~'
+	  && !((wc >= '0' && wc <= '9')
+	       || ((wc & ~0x20) >= 'A' && (wc & ~0x20) <= 'Z')));
+}
+
+static inline int
+iswspace (__wctype_wint_t wc)
+{
+  return (wc == ' ' || wc == '\t'
+	  || wc == '\n' || wc == '\v' || wc == '\f' || wc == '\r');
+}
+
+static inline int
+iswupper (__wctype_wint_t wc)
+{
+  return wc >= 'A' && wc <= 'Z';
+}
+
+static inline int
+iswxdigit (__wctype_wint_t wc)
+{
+  return ((wc >= '0' && wc <= '9')
+	  || ((wc & ~0x20) >= 'A' && (wc & ~0x20) <= 'F'));
+}
+
+# endif /* ! HAVE_ISWCNTRL */
+
+#endif /* _GL_WCTYPE_H */
+#endif /* _GL_WCTYPE_H */
diff -uNr nagios-plugins-1.4.11/gl/xalloc-die.c nagios-plugins-1.4.12/gl/xalloc-die.c
--- nagios-plugins-1.4.11/gl/xalloc-die.c	2007-01-24 23:47:25.000000000 +0100
+++ nagios-plugins-1.4.12/gl/xalloc-die.c	2008-02-12 12:07:18.000000000 +0100
@@ -3,10 +3,10 @@
    Copyright (C) 1997, 1998, 1999, 2000, 2002, 2003, 2004, 2006 Free
    Software Foundation, Inc.
 
-   This program is free software; you can redistribute it and/or modify
+   This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
-   the Free Software Foundation; either version 2, or (at your option)
-   any later version.
+   the Free Software Foundation; either version 3 of the License, or
+   (at your option) any later version.
 
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
@@ -14,8 +14,7 @@
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
-   along with this program; if not, write to the Free Software Foundation,
-   Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.  */
+   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */
 
 #include <config.h>
 
diff -uNr nagios-plugins-1.4.11/gl/xalloc.h nagios-plugins-1.4.12/gl/xalloc.h
--- nagios-plugins-1.4.11/gl/xalloc.h	2007-01-24 23:47:25.000000000 +0100
+++ nagios-plugins-1.4.12/gl/xalloc.h	2008-02-12 12:07:18.000000000 +0100
@@ -1,12 +1,12 @@
 /* xalloc.h -- malloc with out-of-memory checking
 
    Copyright (C) 1990, 1991, 1992, 1993, 1994, 1995, 1996, 1997, 1998,
-   1999, 2000, 2003, 2004, 2006 Free Software Foundation, Inc.
+   1999, 2000, 2003, 2004, 2006, 2007, 2008 Free Software Foundation, Inc.
 
-   This program is free software; you can redistribute it and/or modify
+   This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
-   the Free Software Foundation; either version 2, or (at your option)
-   any later version.
+   the Free Software Foundation; either version 3 of the License, or
+   (at your option) any later version.
 
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
@@ -14,8 +14,7 @@
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
-   along with this program; if not, write to the Free Software Foundation,
-   Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.  */
+   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */
 
 #ifndef XALLOC_H_
 # define XALLOC_H_
@@ -29,7 +28,7 @@
 
 
 # ifndef __attribute__
-#  if __GNUC__ < 2 || (__GNUC__ == 2 && __GNUC_MINOR__ < 8) || __STRICT_ANSI__
+#  if __GNUC__ < 2 || (__GNUC__ == 2 && __GNUC_MINOR__ < 8)
 #   define __attribute__(x)
 #  endif
 # endif
@@ -139,10 +138,10 @@
    allocating an initial block with a nonzero size, or by allocating a
    larger block.
 
-   In the following implementation, nonzero sizes are doubled so that
-   repeated reallocations have O(N log N) overall cost rather than
-   O(N**2) cost, but the specification for this function does not
-   guarantee that sizes are doubled.
+   In the following implementation, nonzero sizes are increased by a
+   factor of approximately 1.5 so that repeated reallocations have
+   O(N) overall cost rather than O(N**2) cost, but the
+   specification for this function does not guarantee that rate.
 
    Here is an example of use:
 
@@ -204,9 +203,13 @@
     }
   else
     {
-      if (((size_t) -1) / 2 / s < n)
+      /* Set N = ceil (1.5 * N) so that progress is made if N == 1.
+	 Check for overflow, so that N * S stays in size_t range.
+	 The check is slightly conservative, but an exact check isn't
+	 worth the trouble.  */
+      if ((size_t) -1 / 3 * 2 / s <= n)
 	xalloc_die ();
-      n *= 2;
+      n += (n + 1) / 2;
     }
 
   *pn = n;
diff -uNr nagios-plugins-1.4.11/gl/xmalloc.c nagios-plugins-1.4.12/gl/xmalloc.c
--- nagios-plugins-1.4.11/gl/xmalloc.c	2007-01-24 23:47:25.000000000 +0100
+++ nagios-plugins-1.4.12/gl/xmalloc.c	2008-02-12 12:07:18.000000000 +0100
@@ -4,10 +4,10 @@
    1999, 2000, 2002, 2003, 2004, 2005, 2006 Free Software Foundation,
    Inc.
 
-   This program is free software; you can redistribute it and/or modify
+   This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
-   the Free Software Foundation; either version 2, or (at your option)
-   any later version.
+   the Free Software Foundation; either version 3 of the License, or
+   (at your option) any later version.
 
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
@@ -15,8 +15,7 @@
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
-   along with this program; if not, write to the Free Software Foundation,
-   Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.  */
+   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */
 
 #include <config.h>
 
diff -uNr nagios-plugins-1.4.11/gl/xsize.h nagios-plugins-1.4.12/gl/xsize.h
--- nagios-plugins-1.4.11/gl/xsize.h	2007-01-24 23:47:25.000000000 +0100
+++ nagios-plugins-1.4.12/gl/xsize.h	2008-02-12 12:07:18.000000000 +0100
@@ -4,7 +4,7 @@
 
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
-   the Free Software Foundation; either version 2, or (at your option)
+   the Free Software Foundation; either version 3, or (at your option)
    any later version.
 
    This program is distributed in the hope that it will be useful,
diff -uNr nagios-plugins-1.4.11/gl/xstrndup.c nagios-plugins-1.4.12/gl/xstrndup.c
--- nagios-plugins-1.4.11/gl/xstrndup.c	2007-01-24 23:47:25.000000000 +0100
+++ nagios-plugins-1.4.12/gl/xstrndup.c	2008-02-12 12:07:18.000000000 +0100
@@ -1,11 +1,11 @@
 /* Duplicate a bounded initial segment of a string, with out-of-memory
    checking.
-   Copyright (C) 2003, 2006 Free Software Foundation, Inc.
+   Copyright (C) 2003, 2006, 2007 Free Software Foundation, Inc.
 
-   This program is free software; you can redistribute it and/or modify
+   This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
-   the Free Software Foundation; either version 2, or (at your option)
-   any later version.
+   the Free Software Foundation; either version 3 of the License, or
+   (at your option) any later version.
 
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
@@ -13,15 +13,14 @@
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
-   along with this program; if not, write to the Free Software Foundation,
-   Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.  */
+   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */
 
 #include <config.h>
 
 /* Specification.  */
 #include "xstrndup.h"
 
-#include "strndup.h"
+#include <string.h>
 #include "xalloc.h"
 
 /* Return a newly allocated copy of at most N bytes of STRING.
diff -uNr nagios-plugins-1.4.11/gl/xstrndup.h nagios-plugins-1.4.12/gl/xstrndup.h
--- nagios-plugins-1.4.11/gl/xstrndup.h	2007-01-24 23:47:25.000000000 +0100
+++ nagios-plugins-1.4.12/gl/xstrndup.h	2008-02-12 12:07:18.000000000 +0100
@@ -2,10 +2,10 @@
    checking.
    Copyright (C) 2003 Free Software Foundation, Inc.
 
-   This program is free software; you can redistribute it and/or modify
+   This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
-   the Free Software Foundation; either version 2, or (at your option)
-   any later version.
+   the Free Software Foundation; either version 3 of the License, or
+   (at your option) any later version.
 
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
@@ -13,8 +13,7 @@
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
-   along with this program; if not, write to the Free Software Foundation,
-   Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.  */
+   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */
 
 #include <stddef.h>
 
diff -uNr nagios-plugins-1.4.11/lib/extra_opts.c nagios-plugins-1.4.12/lib/extra_opts.c
--- nagios-plugins-1.4.11/lib/extra_opts.c	1970-01-01 01:00:00.000000000 +0100
+++ nagios-plugins-1.4.12/lib/extra_opts.c	2008-04-04 12:11:22.000000000 +0200
@@ -0,0 +1,142 @@
+/*****************************************************************************
+* 
+* Nagios-plugins extra_opts library
+* 
+* License: GPL
+* Copyright (c) 2007 Nagios Plugins Development Team
+* 
+* Last Modified: $Date: 2008-03-15 18:42:01 -0400 (Sat, 15 Mar 2008) $
+* 
+* 
+* This program is free software: you can redistribute it and/or modify
+* it under the terms of the GNU General Public License as published by
+* the Free Software Foundation, either version 3 of the License, or
+* (at your option) any later version.
+* 
+* This program is distributed in the hope that it will be useful,
+* but WITHOUT ANY WARRANTY; without even the implied warranty of
+* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+* GNU General Public License for more details.
+* 
+* You should have received a copy of the GNU General Public License
+* along with this program.  If not, see <http://www.gnu.org/licenses/>.
+* 
+* $Id: parse_ini.c 1950 2008-03-15 22:42:01Z dermoth $
+* 
+*****************************************************************************/
+
+#include "common.h"
+#include "utils_base.h"
+#include "parse_ini.h"
+#include "extra_opts.h"
+
+/* FIXME: copied from utils.h; we should move a bunch of libs! */
+int
+is_option2 (char *str)
+{
+	if (!str)
+		return FALSE;
+	else if (strspn (str, "-") == 1 || strspn (str, "-") == 2)
+		return TRUE;
+	else
+		return FALSE;
+}
+
+/* this is the externally visible function used by plugins */
+char **np_extra_opts(int *argc, char **argv, const char *plugin_name){
+	np_arg_list *extra_args=NULL, *ea1=NULL, *ea_tmp=NULL;
+	char **argv_new=NULL;
+	char *argptr=NULL;
+	int i, j, optfound, argc_new, ea_num=*argc;
+
+	if(*argc<2) {
+		/* No arguments provided */
+		return argv;
+	}
+
+	for(i=1; i<*argc; i++){
+		argptr=NULL;
+		optfound=0;
+
+		/* Do we have an extra-opts parameter? */
+		if(strncmp(argv[i], "--extra-opts=", 13)==0){
+			/* It is a single argument with value */
+			argptr=argv[i]+13;
+			/* Delete the extra opts argument */
+			for(j=i;j<*argc;j++) argv[j]=argv[j+1];
+			i--;
+			*argc-=1;
+		}else if(strcmp(argv[i], "--extra-opts")==0){
+			if((i+1<*argc)&&!is_option2(argv[i+1])){
+				/* It is a argument with separate value */
+				argptr=argv[i+1];
+				/* Delete the extra-opts argument/value */
+				for(j=i;j<*argc-1;j++) argv[j]=argv[j+2];
+				i-=2;
+				*argc-=2;
+				ea_num--;
+			}else{
+				/* It has no value */
+				optfound=1;
+				/* Delete the extra opts argument */
+				for(j=i;j<*argc;j++) argv[j]=argv[j+1];
+				i--;
+				*argc-=1;
+			}
+		}
+
+		/* If we found extra-opts, expand them and store them for later*/
+		if(argptr||optfound){
+			/* Process ini section, returning a linked list of arguments */
+			ea1=np_get_defaults(argptr, plugin_name);
+			if(ea1==NULL) {
+				/* no extra args (empty section)? */
+				ea_num--;
+				continue;
+			}
+
+			/* append the list to extra_args */
+			if(extra_args==NULL){
+				extra_args=ea1;
+				while(ea1=ea1->next) ea_num++;
+			}else{
+				ea_tmp=extra_args;
+				while(ea_tmp->next) {
+					ea_tmp=ea_tmp->next;
+					ea_num++;
+				}
+				ea_tmp->next=ea1;
+			}
+			ea1=ea_tmp=NULL;
+		}
+		/* lather, rince, repeat */
+	}
+
+	if(ea_num==*argc && extra_args==NULL){
+		/* No extra-opts */
+		return argv;
+	}
+
+	/* done processing arguments. now create a new argv array... */
+	argv_new=(char**)malloc((ea_num+1)*sizeof(char**));
+	if(argv_new==NULL) die(STATE_UNKNOWN, _("malloc() failed!\n"));
+
+	/* starting with program name */
+	argv_new[0]=argv[0];
+	argc_new=1;
+	/* then parsed ini opts (frying them up in the same run) */
+	while(extra_args){
+		argv_new[argc_new++]=extra_args->arg;
+		ea1=extra_args;
+		extra_args=extra_args->next;
+		free(ea1);
+	}
+	/* finally the rest of the argv array */
+	for (i=1; i<*argc; i++)	argv_new[argc_new++]=argv[i];
+	*argc=argc_new;
+	/* and terminate. */
+	argv_new[argc_new]=NULL;
+
+	return argv_new;
+}
+
diff -uNr nagios-plugins-1.4.11/lib/extra_opts.h nagios-plugins-1.4.12/lib/extra_opts.h
--- nagios-plugins-1.4.11/lib/extra_opts.h	1970-01-01 01:00:00.000000000 +0100
+++ nagios-plugins-1.4.12/lib/extra_opts.h	2008-04-01 11:31:27.000000000 +0200
@@ -0,0 +1,20 @@
+#ifndef _EXTRA_OPTS_H_
+#define _EXTRA_OPTS_H_
+
+/*
+ * extra_opts.h: routines for loading nagios-plugin defaults from ini
+ * configuration files.
+ */
+
+/* np_extra_opts: Process the --extra-opts arguments and create a new argument
+ * array with ini-processed and argument-passed arguments together. The
+ * ini-procesed arguments always come first (in the ord of --extra-opts
+ * arguments). If no --extra-opts arguments are provided or returned nothing
+ * it returns **argv otherwise the new array is returned. --extra-opts are
+ * always removed from **argv. The original pointers from **argv are kept in
+ * the new array to preserve ability to overwrite arguments in processlist.
+ */
+char **np_extra_opts(int *argc, char **argv, const char *plugin_name);
+
+#endif /* _EXTRA_OPTS_H_ */
+
diff -uNr nagios-plugins-1.4.11/lib/Makefile.am nagios-plugins-1.4.12/lib/Makefile.am
--- nagios-plugins-1.4.11/lib/Makefile.am	2007-12-12 02:27:48.000000000 +0100
+++ nagios-plugins-1.4.12/lib/Makefile.am	2008-04-02 11:11:44.000000000 +0200
@@ -5,8 +5,12 @@
 noinst_LIBRARIES = libnagiosplug.a
 
 
-libnagiosplug_a_SOURCES = utils_base.c utils_disk.c utils_tcp.c utils_cmd.c base64.c
-EXTRA_DIST = utils_base.h utils_disk.h utils_tcp.h utils_cmd.h base64.h
+libnagiosplug_a_SOURCES = utils_base.c utils_disk.c utils_tcp.c utils_cmd.c
+EXTRA_DIST = utils_base.h utils_disk.h utils_tcp.h utils_cmd.h parse_ini.h extra_opts.h
+
+if USE_PARSE_INI
+libnagiosplug_a_SOURCES += parse_ini.c extra_opts.c
+endif USE_PARSE_INI
 
 INCLUDES = -I$(srcdir) -I$(top_srcdir)/gl -I$(top_srcdir)/intl -I$(top_srcdir)/plugins
 
diff -uNr nagios-plugins-1.4.11/lib/parse_ini.c nagios-plugins-1.4.12/lib/parse_ini.c
--- nagios-plugins-1.4.11/lib/parse_ini.c	1970-01-01 01:00:00.000000000 +0100
+++ nagios-plugins-1.4.12/lib/parse_ini.c	2008-04-04 12:11:22.000000000 +0200
@@ -0,0 +1,368 @@
+/*****************************************************************************
+* 
+* Nagios-plugins parse_ini library
+* 
+* License: GPL
+* Copyright (c) 2007 Nagios Plugins Development Team
+* 
+* Last Modified: $Date: 2008-04-04 11:11:22 +0100 (Fri, 04 Apr 2008) $
+* 
+* 
+* This program is free software: you can redistribute it and/or modify
+* it under the terms of the GNU General Public License as published by
+* the Free Software Foundation, either version 3 of the License, or
+* (at your option) any later version.
+* 
+* This program is distributed in the hope that it will be useful,
+* but WITHOUT ANY WARRANTY; without even the implied warranty of
+* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+* GNU General Public License for more details.
+* 
+* You should have received a copy of the GNU General Public License
+* along with this program.  If not, see <http://www.gnu.org/licenses/>.
+* 
+* $Id: parse_ini.c 1976 2008-04-04 10:11:22Z dermoth $
+* 
+*****************************************************************************/
+
+#include "common.h"
+#include "utils_base.h"
+#include "parse_ini.h"
+#include <ctype.h>
+
+#include <sys/types.h>
+#include <sys/stat.h>
+#include <unistd.h>
+
+/* TODO: die like N::P if config file is not found */
+
+/* np_ini_info contains the result of parsing a "locator" in the format
+ * [stanza_name][@config_filename] (check_foo@/etc/foo.ini, for example)
+ */
+typedef struct {
+	char *file;
+	char *stanza;
+} np_ini_info;
+
+/* eat all characters from a FILE pointer until n is encountered */
+#define GOBBLE_TO(f, c, n) do { (c)=fgetc((f)); } while((c)!=EOF && (c)!=(n))
+
+/* internal function that returns the constructed defaults options */
+static int read_defaults(FILE *f, const char *stanza, np_arg_list **opts);
+/* internal function that converts a single line into options format */
+static int add_option(FILE *f, np_arg_list **optlst);
+/* internal function to find default file */
+static char* default_file(void);
+/* internal function to stat() files */
+static int test_file(const char* env, int len, const char* file, char* temp_file);
+
+/* parse_locator decomposes a string of the form
+ * 	[stanza][@filename]
+ * into its seperate parts
+ */
+static void parse_locator(const char *locator, const char *def_stanza, np_ini_info *i){
+	size_t locator_len=0, stanza_len=0;
+
+	/* if locator is NULL we'll use default values */
+	if(locator){
+		locator_len=strlen(locator);
+		stanza_len=strcspn(locator, "@");
+	}
+	/* if a non-default stanza is provided */
+	if(stanza_len>0){
+		i->stanza=(char*)malloc(sizeof(char)*(stanza_len+1));
+		strncpy(i->stanza, locator, stanza_len);
+		i->stanza[stanza_len]='\0';
+	} else { /* otherwise we use the default stanza */
+		i->stanza=strdup(def_stanza);
+	}
+	/* if there is no @file part */
+	if(stanza_len==locator_len){
+		i->file=default_file();
+	} else {
+		i->file=strdup(&(locator[stanza_len+1]));
+	}
+	
+	if(i->file==NULL || i->stanza==NULL){
+		die(STATE_UNKNOWN, _("malloc() failed!\n"));
+	}
+}
+
+/* this is the externally visible function used by extra_opts */
+np_arg_list* np_get_defaults(const char *locator, const char *default_section){
+	FILE *inifile=NULL;
+	np_arg_list *defaults=NULL;
+	np_ini_info i;
+
+	parse_locator(locator, default_section, &i);
+	/* if a file was specified or if we're using the default file */
+	if(i.file != NULL && strlen(i.file) > 0){
+		if(strcmp(i.file, "-")==0){
+			inifile=stdin;
+		} else {
+			inifile=fopen(i.file, "r");
+		}
+		if(inifile==NULL) die(STATE_UNKNOWN, _("Can't read config file"));
+		if(read_defaults(inifile, i.stanza, &defaults)==FALSE)
+			die(STATE_UNKNOWN, _("Invalid section '%s' in config file '%s'\n"), i.stanza, i.file);
+
+		free(i.file);
+		if(inifile!=stdin) fclose(inifile);
+	}
+	free(i.stanza);
+	return defaults;	
+}
+
+/* read_defaults is where the meat of the parsing takes place.
+ *
+ * note that this may be called by a setuid binary, so we need to
+ * be extra careful about user-supplied input (i.e. avoiding possible
+ * format string vulnerabilities, etc)
+ */
+static int read_defaults(FILE *f, const char *stanza, np_arg_list **opts){
+	int c, status=FALSE;
+	size_t i, stanza_len;
+	enum { NOSTANZA, WRONGSTANZA, RIGHTSTANZA } stanzastate=NOSTANZA;
+
+	stanza_len=strlen(stanza);
+
+	/* our little stanza-parsing state machine.  */
+	while((c=fgetc(f))!=EOF){
+		/* gobble up leading whitespace */
+		if(isspace(c)) continue;
+		switch(c){
+			/* globble up coment lines */
+			case '#':
+				GOBBLE_TO(f, c, '\n');
+				break;
+			/* start of a stanza.  check to see if it matches */
+			case '[':
+				stanzastate=WRONGSTANZA;
+				for(i=0; i<stanza_len; i++){
+					c=fgetc(f);
+					/* Strip leading whitespace */
+					if(i==0) for(c; isspace(c); c=fgetc(f));
+					/* nope, read to the end of the line */
+					if(c!=stanza[i]) {
+						GOBBLE_TO(f, c, '\n');
+						break;
+					}
+				}
+				/* if it matched up to here and the next char is ']'... */
+				if(i==stanza_len){
+					c=fgetc(f);
+					/* Strip trailing whitespace */
+					for(c; isspace(c); c=fgetc(f));
+					if(c==']') stanzastate=RIGHTSTANZA;
+				}
+				break;
+			/* otherwise, we're in the body of a stanza or a parse error */
+			default:
+				switch(stanzastate){
+					/* we never found the start of the first stanza, so
+					 * we're dealing with a config error 
+					 */
+					case NOSTANZA:
+						die(STATE_UNKNOWN, _("Config file error"));
+						break;
+					/* we're in a stanza, but for a different plugin */
+					case WRONGSTANZA:
+						GOBBLE_TO(f, c, '\n');
+						break;
+					/* okay, this is where we start taking the config */
+					case RIGHTSTANZA:
+						ungetc(c, f);
+						if(add_option(f, opts)){
+							die(STATE_UNKNOWN, _("Config file error"));
+						}
+						status=TRUE;
+						break;
+				}
+				break;
+		}
+	}
+	return status;
+}
+
+/*
+ * read one line of input in the format
+ * 	^option[[:space:]]*(=[[:space:]]*value)?
+ * and creates it as a cmdline argument
+ * 	--option[=value]
+ * appending it to the linked list optbuf.
+ */
+static int add_option(FILE *f, np_arg_list **optlst){
+	np_arg_list *opttmp=*optlst, *optnew;
+	char *linebuf=NULL, *lineend=NULL, *optptr=NULL, *optend=NULL;
+	char *eqptr=NULL, *valptr=NULL, *spaceptr=NULL, *valend=NULL;
+	short done_reading=0, equals=0, value=0;
+	size_t cfg_len=0, read_sz=8, linebuf_sz=0, read_pos=0;
+	size_t opt_len=0, val_len=0;
+
+	/* read one line from the file */
+	while(!done_reading){
+		/* grow if necessary */
+		if(linebuf==NULL || read_pos+read_sz >= linebuf_sz){
+			linebuf_sz=(linebuf_sz>0)?linebuf_sz<<1:read_sz;
+			linebuf=realloc(linebuf, linebuf_sz);
+			if(linebuf==NULL) die(STATE_UNKNOWN, _("malloc() failed!\n"));
+		}
+		if(fgets(&linebuf[read_pos], read_sz, f)==NULL) done_reading=1;
+		else {
+			read_pos=strlen(linebuf);
+			if(linebuf[read_pos-1]=='\n') {
+				linebuf[--read_pos]='\0';
+				done_reading=1;
+			}
+		}
+	}
+	lineend=&linebuf[read_pos];
+	/* all that to read one line.  isn't C fun? :) now comes the parsing :/ */
+
+	/* skip leading whitespace */
+	for(optptr=linebuf; optptr<lineend && isspace(*optptr); optptr++);
+	/* continue to '=' or EOL, watching for spaces that might precede it */
+	for(eqptr=optptr; eqptr<lineend && *eqptr!='='; eqptr++){
+		if(isspace(*eqptr) && optend==NULL) optend=eqptr;
+		else optend=NULL;
+	}
+	if(optend==NULL) optend=eqptr;
+	--optend;
+	/* ^[[:space:]]*=foo is a syntax error */
+	if(optptr==eqptr) die(STATE_UNKNOWN, _("Config file error\n"));
+	/* continue from '=' to start of value or EOL */
+	for(valptr=eqptr+1; valptr<lineend && isspace(*valptr); valptr++);
+	/* continue to the end of value (FIXME: watching for trailing comments) */
+	for(valend=valptr; valend<lineend; valend++)
+		/* FIXME: N::P doesn't allow comments here. Remove next line and parse_ini won't either */
+		if(*valend=='#') break;
+	--valend;
+	/* Finally trim off trailing spaces */
+	for(valend; isspace(*valend); valend--);
+	/* calculate the length of "--foo" */
+	opt_len=1+optend-optptr;
+	/* 1-character params needs only one dash */
+	if(opt_len==1)
+		cfg_len=1+(opt_len);
+	else
+		cfg_len=2+(opt_len);
+	/* if valptr<lineend then we have to also allocate space for "=bar" */
+	if(valptr<lineend) {
+		equals=value=1;
+		val_len=1+valend-valptr;
+		cfg_len+=1+val_len;
+	}
+	/* if valptr==valend then we have "=" but no "bar" */
+	else if(valptr==lineend) {
+		equals=1;
+		cfg_len+=1;
+	}
+	/* A line with no equal sign isn't valid */
+	if(equals==0) die(STATE_UNKNOWN, _("Config file error\n"));
+
+	/* okay, now we have all the info we need, so we create a new np_arg_list
+	 * element and set the argument...
+	 */
+	optnew=(np_arg_list *)malloc(sizeof(np_arg_list));
+	optnew->next=NULL;
+
+	read_pos=0;
+	optnew->arg=(char *)malloc(cfg_len+1);
+	/* 1-character params needs only one dash */
+	if(opt_len==1) {
+		strncpy(&optnew->arg[read_pos], "-", 1);
+		read_pos+=1;
+	} else {
+		strncpy(&optnew->arg[read_pos], "--", 2);
+		read_pos+=2;
+	}
+	strncpy(&optnew->arg[read_pos], optptr, opt_len); read_pos+=opt_len;
+	if(value) {
+		optnew->arg[read_pos++]='=';
+		strncpy(&optnew->arg[read_pos], valptr, val_len); read_pos+=val_len;
+	}
+	optnew->arg[read_pos]='\0';
+
+	/* ...and put that to the end of the list */
+	if(*optlst==NULL) {
+		*optlst=optnew;
+	}	else {
+		while(opttmp->next!=NULL) {
+			opttmp=opttmp->next;
+		}
+		opttmp->next = optnew;
+	}
+
+	free(linebuf);
+	return 0;
+}
+
+static char* default_file(void){
+	struct stat sb;
+	char *np_env=NULL, *default_file=NULL;
+	char temp_file[MAX_INPUT_BUFFER];
+	size_t len;
+
+	if((np_env=getenv("NAGIOS_CONFIG_PATH"))!=NULL) {
+		/* skip ant starting colon... */
+		while(*np_env==':') np_env++;
+		/* Look for NP_DEFAULT_INI_FILENAME1 and NP_DEFAULT_INI_FILENAME2 in
+		 * every PATHs defined (colon-separated).
+		 */
+		while((len=strcspn(np_env,":"))>0){
+			/* Test NP_DEFAULT_INI_FILENAME[1-2] in current np_env token */
+			if(test_file(np_env,len,NP_DEFAULT_INI_FILENAME1,temp_file)==1 ||
+			   test_file(np_env,len,NP_DEFAULT_INI_FILENAME2,temp_file)==1){
+				default_file=strdup(temp_file);
+				break;
+			}
+
+			/* Move on to the next token */
+			np_env+=len;
+			while(*np_env==':') np_env++;
+		} /* while(...) */
+	} /* if(getenv("NAGIOS_CONFIG_PATH")) */
+
+	/* Look for NP_DEFAULT_INI_FILENAME1 in NP_DEFAULT_INI_NAGIOS_PATH[1-4] */
+	if(!default_file){
+		if(test_file(NP_DEFAULT_INI_NAGIOS_PATH1,strlen(NP_DEFAULT_INI_NAGIOS_PATH1),NP_DEFAULT_INI_FILENAME1,temp_file)==1 ||
+		   test_file(NP_DEFAULT_INI_NAGIOS_PATH2,strlen(NP_DEFAULT_INI_NAGIOS_PATH2),NP_DEFAULT_INI_FILENAME1,temp_file)==1 ||
+		   test_file(NP_DEFAULT_INI_NAGIOS_PATH3,strlen(NP_DEFAULT_INI_NAGIOS_PATH3),NP_DEFAULT_INI_FILENAME1,temp_file)==1 ||
+		   test_file(NP_DEFAULT_INI_NAGIOS_PATH4,strlen(NP_DEFAULT_INI_NAGIOS_PATH4),NP_DEFAULT_INI_FILENAME1,temp_file)==1)
+			default_file=strdup(temp_file);
+	}
+
+	/* Look for NP_DEFAULT_INI_FILENAME2 in NP_DEFAULT_INI_PATH[1-3] */
+	if(!default_file){
+		if(test_file(NP_DEFAULT_INI_PATH1,strlen(NP_DEFAULT_INI_PATH1),NP_DEFAULT_INI_FILENAME2,temp_file)==1 ||
+		   test_file(NP_DEFAULT_INI_PATH2,strlen(NP_DEFAULT_INI_PATH2),NP_DEFAULT_INI_FILENAME2,temp_file)==1 ||
+		   test_file(NP_DEFAULT_INI_PATH3,strlen(NP_DEFAULT_INI_PATH3),NP_DEFAULT_INI_FILENAME2,temp_file)==1)
+			default_file=strdup(temp_file);
+	}
+
+	/* Return default_file or empty string (should return NULL if we want to
+	 * die there...
+	 */
+	if(default_file)
+		return default_file;
+	return "";
+}
+
+/* put together len bytes from env and the filename and test for its
+ * existence. Returns 1 if found, 0 if not and -1 if test wasn't performed.
+ */
+static int test_file(const char* env, int len, const char* file, char* temp_file){
+	struct stat sb;
+
+	/* test for len + filelen + '/' + '\0' */
+	if((len+strlen(file)+2)>MAX_INPUT_BUFFER)	return -1;
+
+	strncpy(temp_file,env,len);
+	temp_file[len]='\0';
+	strncat(temp_file,"/",len+1);
+	strncat(temp_file,file,len+strlen(file)+1);
+
+	if(stat(temp_file, &sb) != -1) return 1;
+	return 0;
+}
+
